#include <sys/time.h>
#include <signal.h>
#include <stdio.h>


static void onalarm(int sig) {
	if(settings&&sensors) {
		LOGGER("onalarm do it\n");
		sensors->removeoldstates();
		}
	else
		LOGGER("onalarm no init\n");
	}

static void setalarm() {
	signal(SIGALRM,onalarm);
        struct itimerval val { {60*60*24,0},{60*4,0}};
	LOGGER("set alarm %ld %ld\n",val.it_interval.tv_sec, val.it_value.tv_sec);
	setitimer(ITIMER_REAL,&val,nullptr);
	}
