
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <unistd.h>
#include "destruct.h"
#include "logs.h"
#include "netstuff.h"
#if 0
        struct sockaddr_in6 {
               sa_family_t     sin6_family;   /* AF_INET6 */
               in_port_t       sin6_port;     /* port number */
               uint32_t        sin6_flowinfo; /* IPv6 flow information */
               struct in6_addr sin6_addr;     /* IPv6 address */
               uint32_t        sin6_scope_id; /* Scope ID (new in 2.4) */
           };

           struct in6_addr {
               unsigned char   s6_addr[16];   /* IPv6 address */
           };
#endif 

bool  getaddr(const struct sockaddr *sa, struct sockaddr_in6  *uit) {
	switch(sa->sa_family) {
		case AF_INET: 
			{
			*uit={.sin6_family=AF_INET6, .sin6_port=((struct sockaddr_in *)sa)->sin_port, .sin6_addr=v426(sa)};	
			return true;
			}
		case AF_INET6: *uit=*((struct sockaddr_in6*)sa);return true;
		default: return false; 
		}
	}
bool   getaddr(const char *host, const char *port, struct sockaddr_in6  *uit) {
	struct addrinfo hints{.ai_flags=AI_ADDRCONFIG|AI_NUMERICHOST,.ai_family=AF_UNSPEC,.ai_socktype=SOCK_STREAM};
	struct addrinfo *servinfo=nullptr;
	destruct serv([&servinfo]{ if(servinfo)freeaddrinfo(servinfo);});
	if(int status=getaddrinfo(host,port,&hints,&servinfo)) {
		LOGGER("getaddrinfo: %s:%s %s\n",host,port,gai_strerror(status));
		return false; 
		}
	return getaddr(servinfo->ai_addr,uit);
	}
/*

struct in6_addr {
  union {
    __u8 u6_addr8[16];

    __be16 u6_addr16[8];
    __be32 u6_addr32[4];

  } in6_u;





};

struct in6_addr
  {
    union
      {
 uint8_t __u6_addr8[16];
 uint16_t __u6_addr16[8];
 uint32_t __u6_addr32[4];
      } __in6_u;





  };

*/
/* IPv6 Wildcard Address (::) and Loopback Address (::1) defined in RFC2553
 * NOTE: Be aware the IN6ADDR_* constants and in6addr_* externals are defined
 * in network byte order, not in host byte order as are the IPv4 equivalents
 */

#ifdef MAIN2
int main(int argc,char **argv) {

struct sockaddr_in6  uit;
getaddr(argv[1],argv[2],&uit);
char name[INET6_ADDRSTRLEN];
inet_ntop( AF_INET6,&uit.sin6_addr ,name, sizeof name);
printf("inet_ntop=%s\n",name);
    char hbuf[NI_MAXHOST], sbuf[NI_MAXSERV];
//   if (getnameinfo((sockaddr *)&addr, addrlen, hbuf, sizeof(hbuf), sbuf, sizeof(sbuf), NI_NUMERICHOST | NI_NUMERICSERV) == 0)
   if (getnameinfo((sockaddr *)&uit, sizeof(uit), hbuf, sizeof(hbuf), sbuf, sizeof(sbuf),0) == 0)
               printf("host=%s, serv=%s\n", hbuf, sbuf);
namehost name2(&uit);
printf("host2=%s\n",name2.data());
}

	#endif
